{-------------------------------------------------------------------------
 qrd3rdpartycontrol_TDBRichView;

 Include this file in your project and the RichView control will be on the
 QRDesign editor toolbar. qrd3rdpartycontrol_TDBRichView.res is also required.

 (c) 2010 QBS Software Ltd

 ------------------------------------------------------------------------}

{$I QRDESIGN.INC}

unit qrd3rdpartycontrol_TDBRichView;

interface

uses
    DBTables, DB, SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, comctrls, Buttons, ExtCtrls, QRDesign, QRDCtrls,
  quickrpt, RVQRCtrls, RVScroll, RichView, RVEdit, RVStyle;

const
   CRLF = chr(13)+chr(10);
type
  TRVContentType = (ctRTF,ctRVF);

  TDBRichViewPropEd = class(TForm)
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    Label2: TLabel;
    CheckBox3: TCheckBox;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    TreeView1: TTreeView;
    ComboBox4: TComboBox;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
   rvStyle : TRVStyle;
  end;

  TQRDBDesignRichView = class(TQRRichView)
  private
    FDatafieldName : string;
    FDatafield : TField;
    FDataset : TDataset;
    FContentType : TRVContentType;
    procedure Prepare;override;
  protected
  public
    constructor Create(AOwner: TComponent);override;
    procedure Paint; override;
    procedure Print(OfsX, OfsY: integer); override;
  published
    property ContentType : TRVContentType read FContentType write FContentType;
    property DatafieldName : string read FDatafieldName write FDatafieldName;
    property AutoStretch;
    property AutoPages;
    property ColorMode;
    property TransparentBackground;
  end;

var
    DBRichViewPropEd: TDBRichViewPropEd;
    rvfilename : string;
    fileExtension : string;
    clist : TStringlist;
    tempStream : TMemorystream;

    function GetNodeByText (ATree : TTreeView; AValue:String; AVisible: Boolean): TTreeNode;
    procedure EditDBRichView(QRDesigner: TQRepDesigner; Control: TQRPrintable;
                                                      var Result: Boolean);

{------------------------------------------------------------------------------}

implementation

{$R *.DFM}

{$R *.RES} { include resource file containing button glyph for report editor }

uses
  {$IFNDEF VER100}
  {$ENDIF}
  qrd3rdPartyControls, qrdQuickrep, qrdConst;


constructor TQRDBDesignRichView.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
end;

procedure TQRDBDesignRichView.Print(OfsX, OfsY : integer);
begin
    if FDatafield = nil then exit;
    clist := TStringlist.Create;
    tempstream := TMemorystream.Create;
    try
        if (FDatafield is TMemoField) or (FDatafield is TStringField) then
        begin
          clist.Text := TMemoField(FDatafield).AsString;
          clist.SaveToStream(tempstream);
        end
        else if (FDatafield is TBlobField) then
        begin
          TBlobField(FDatafield).SaveToStream(tempstream);
        end;
        //tempstream.SaveToFile('tracecontent.txt');
        tempstream.Position := 0;
        if self.FContentType = ctRTF then
               self.LoadRTFStream(tempstream)
        else
               self.LoadRVFStream(tempstream);

        clist.Free;
        tempstream.Free;
    except
        clist.Free;
        tempstream.Free;
    end;
    inherited Print(OfsX,OfsY);
end;

procedure TQRDBDesignRichView.Prepare;
var
   p : integer;
   datastr : string;
begin
    inherited Prepare;
    FDataset := TQuickrep((TQRPrintable(self)).Parentreport).dataset;
    if FDataset = nil then exit;
    FDatafield := nil;
    for p := 0 to FDataset.FieldCount-1 do
    begin
         if FDataset.Fields[p].FieldName=FDatafieldname then
         begin
              FDatafield := FDataset.Fields[p];
              break;
         end;
    end;
end;

procedure TQRDBDesignRichView.Paint;
begin
  Inherited Paint;
  If (Owner is TDesignQuickreport) Then
    TDesignQuickreport(Owner).ShowComponentFrame(Self);
end;

{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}

procedure TDBRichViewPropEd.FormCreate(Sender: TObject);
begin
  TranslateForm(Self, 'TRichViewPropEd');
  combobox4.Items.Add('RTF');
  combobox4.Items.Add('RVF');
  combobox4.Text := '';
  combobox1.Items.Add('rvcmColor');
  combobox1.Items.Add('rvcmPrinterColor');
  combobox1.Items.Add('rvcmGrayScale');
  combobox1.Items.Add('rvcmBlackAndWhite');
  combobox1.Items.Add('rvcmBlackOnWhite');

  combobox2.Items.Add('rvf_sIgnore');
  combobox2.Items.Add('rvf_sInsertMap');
  combobox2.Items.Add('rvf_sInsertMerge');

  combobox3.Items.Add('rvf_sIgnore');
  combobox3.Items.Add('rvf_sInsertMap');
  combobox3.Items.Add('rvf_sInsertMerge');

end;

{--------------------------------------------------------------------------------}
{--------------------------------------------------------------------------------}

procedure EditDBRichView(QRDesigner: TQRepDesigner; Control: TQRPrintable; var Result: Boolean);
var
  QRRT: TQRDBDesignRichView;
  tstr : string;
  hexstream : TMemorystream;
  dflist : TTreeview;
  fnode : TTreenode;
  k : integer;
begin
  QRRT:=TQRDBDesignRichView(Control);
  DBRichViewPropEd := TDBRichViewPropEd.Create(QRDesigner.Owner);
  DBRichViewPropEd.Edit1.Text := QRRT.Name;
  DBRichViewPropEd.CheckBox1.Checked := QRRT.AutoStretch;
  DBRichViewPropEd.CheckBox2.Checked := QRRT.AutoPages;
  DBRichViewPropEd.CheckBox3.Checked := QRRT.TransparentBackground;
  if QRRT.ColorMode = rvcmColor then
     DBRichViewPropEd.combobox1.Text := 'rvcmColor'
  else if QRRT.ColorMode = rvcmPrinterColor then
     DBRichViewPropEd.combobox1.Text := 'rvcmPrinterColor'
  else if QRRT.ColorMode = rvcmGrayScale then
     DBRichViewPropEd.combobox1.Text := 'rvcmGrayScale'
  else if QRRT.ColorMode = rvcmBlackAndWhite then
     DBRichViewPropEd.combobox1.Text := 'rvcmBlackAndWhite'
  else if QRRT.ColorMode = rvcmBlackOnWhite then
     DBRichViewPropEd.combobox1.Text := 'rvcmBlackOnWhite';
  if QRRT.FContentType = ctRTF then
               DBRichViewPropEd.combobox4.Text := 'RTF'
  else if QRRT.FContentType = ctRVF then
               DBRichViewPropEd.combobox4.Text := 'RVF';
  // populate fields combo
  dflist := TTreeview( QRDesigner.DatafieldListbox);
  DBRichViewPropEd.Treeview1.Items.Assign( dflist.Items );
  // set datafield on Treeview
  if QRRT.FDatafieldName <> '' then
  begin
       fnode := GetNodeByText( DBRichViewPropEd.TreeView1, QRRT.FDatafieldName, true);
       if fnode <> nil then  // Problem : the node is not highlighted, but is selected
           DBRichViewPropEd.TreeView1.Select(fnode);
  end;
  Result := DBRichViewPropEd.ShowModal = mrOk;
  if Result then
  begin
       QRRT.Name := DBRichViewPropEd.Edit1.Text;
       QRRT.AutoStretch := DBRichViewPropEd.CheckBox1.Checked;
       QRRT.AutoPages := DBRichViewPropEd.CheckBox2.Checked;
       QRRT.TransparentBackground := DBRichViewPropEd.CheckBox3.Checked;
       // colour option
       if DBRichViewPropEd.combobox1.Text = 'rvcmColor' then
          QRRT.ColorMode := rvcmColor
       else if DBRichViewPropEd.combobox1.Text = 'rvcmPrinterColor' then
          QRRT.ColorMode := rvcmPrinterColor
       else if DBRichViewPropEd.combobox1.Text = 'rvcmGrayScale' then
          QRRT.ColorMode := rvcmGrayScale
       else if DBRichViewPropEd.combobox1.Text = 'rvcmBlackAndWhite' then
          QRRT.ColorMode := rvcmBlackAndWhite
       else if DBRichViewPropEd.combobox1.Text = 'rvcmBlackOnWhite' then
          QRRT.ColorMode := rvcmBlackOnWhite;
       if DBRichViewPropEd.combobox4.Text = 'RTF' then
          QRRT.FContentType := ctRTF
       else if DBRichViewPropEd.combobox4.Text = 'RVF' then
          QRRT.FContentType := ctRVF;
       if DBRichViewPropEd.Treeview1.Selected<>nil then
          QRRT.FDatafieldName := DBRichViewPropEd.Treeview1.Selected.Text;
  end;
  DBRichViewPropEd.Free;
end;


procedure TDBRichViewPropEd.FormClose(Sender: TObject;  var Action: TCloseAction);
begin
     if edit1.Text = '' then
     begin
         showmessage( 'Please give the control a name');
         action := caNone;
     end;
end;

function GetNodeByText (ATree : TTreeView; AValue:String; AVisible: Boolean): TTreeNode;
var
    Node: TTreeNode;
begin
  Result := nil;
  if ATree.Items.Count = 0 then Exit;
  Node := ATree.Items[0];
  while Node <> nil do
  begin
    if UpperCase(Node.Text) = UpperCase(AValue) then
    begin
      Result := Node;
      if AVisible then
        Result.MakeVisible;
      Break;
    end;
    Node := Node.GetNext;
  end;
end;


initialization
 // see qrdconst.pas for constants '25' below is the next available.
  RegisterQRDThirdPartyControl( 25,
                                TQRDBDesignRichView,
                                EditDBRichView,
                                CreateBitmapFromResource('DBRICHVIEW'),
                                'QRDBRichView');
end.
